'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobx = require('mobx');

var _debouncy = require('debouncy');

var _debouncy2 = _interopRequireDefault(_debouncy);

var _coalescy = require('coalescy');

var _coalescy2 = _interopRequireDefault(_coalescy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var Field = (_class = function (_React$Component) {
  _inherits(Field, _React$Component);

  _createClass(Field, [{
    key: 'clearValidation',
    value: function clearValidation() {
      this._valid = true;
      this.errorMessage = '';
    }
  }, {
    key: 'clearInteractive',
    value: function clearInteractive() {
      this._interacted = false;
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this2 = this;

      var force = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!this._validateFn) {
        return;
      }

      if (!force && !this._interacted) {
        // if we're not forcing the validation
        // and we haven't interacted with the field
        // we asume this field pass the validation status
        this._valid = true;
        this.errorMessage = '';
        return;
      }
      var res = this._validateFn(this, this.model.fields);

      // if the function returned a boolean we assume it is
      // the flag for the valid state
      if (typeof res === 'boolean') {
        this._valid = res;
        this.errorMessage = res ? '' : this._originalErrorMessage;
        return;
      }

      // otherwise we asumme we have received a promise
      var p = Promise.resolve(res);
      return new Promise(function (resolve) {
        // eslint-disable-line consistent-return
        p.then(function () {
          _this2._valid = true;
          _this2.errorMessage = '';
          resolve(); // we use this to chain validators
        }, function () {
          var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
              error = _ref.error;

          _this2.errorMessage = (error || '').trim() || _this2._originalErrorMessage;
          _this2._valid = false;
          resolve(); // we use this to chain validators
        });
      });
    }
  }, {
    key: 'valid',
    get: function get() {
      return this._valid;
    }
  }, {
    key: 'interacted',
    get: function get() {
      return this._interacted;
    }
  }, {
    key: 'value',
    get: function get() {
      if ((0, _mobx.isObservableArray)(this._value)) {
        return [].slice.call(this._value);
      }
      return this._value;
    },
    set: function set(val) {
      if (!this._interacted) {
        this._interacted = true;
      }

      if (this._value === val) {
        return;
      }

      this._value = val;

      if (this._skipValidation) {
        return;
      }

      if (this.interactive) {
        this._debouncedValidation();
      } else {
        this._debounceClearValidation();
      }
    }
  }]);

  function Field(props) {
    _classCallCheck(this, Field);

    var _this = _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).call(this, props));

    _initDefineProp(_this, '_value', _descriptor, _this);

    _this._skipValidation = false;

    _initDefineProp(_this, '_interacted', _descriptor2, _this);

    _initDefineProp(_this, '_valid', _descriptor3, _this);

    _initDefineProp(_this, 'errorMessage', _descriptor4, _this);

    _initDefineProp(_this, 'interactive', _descriptor5, _this);

    return _this;
  }

  _createClass(Field, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        'Hello world'
      );
    }
  }]);

  return Field;
}(_react2.default.Component), (_descriptor = _applyDecoratedDescriptor(_class.prototype, '_value', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, '_interacted', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, '_valid', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return true;
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'errorMessage', [_mobx.observable], {
  enumerable: true,
  initializer: null
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'interactive', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return true;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'valid', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'valid'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'interacted', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'interacted'), _class.prototype)), _class);
exports.default = Field;
module.exports = exports['default'];