'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2;

exports.createModel = createModel;

var _mobx = require('mobx');

var _Field = require('./Field');

var _Field2 = _interopRequireDefault(_Field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var FormModel = (_class = function () {
  _createClass(FormModel, [{
    key: 'clearValues',
    value: function clearValues(obj) {
      var _this = this;

      (0, _mobx.transaction)(function () {
        Object.keys(obj).forEach(function (key) {
          return _this.updateField(key, obj[key], true);
        });
      });
    }
  }, {
    key: 'fieldKeys',
    value: function fieldKeys() {
      return Object.keys(this.fields);
    }
  }, {
    key: 'getField',
    value: function getField(field) {
      var theField = this.fields[field];
      if (!theField) {
        throw new Error('Field ' + field + ' not found');
      }
      return theField;
    }
  }, {
    key: 'valueOf',
    value: function valueOf(field) {
      return this.getField(field).value;
    }
  }, {
    key: 'validate',
    value: function validate() {
      var _this2 = this;

      this.validating = true;

      var p = this.fieldKeys().reduce(function (seq, key) {
        var field = _this2.fields[key];
        return seq.then(function () {
          return field.validate(true);
        });
      }, Promise.resolve());

      p.then(function () {
        return _this2.validating = false;
      });

      return p;
    }
  }, {
    key: 'updateField',
    value: function updateField(field, value, reset) {
      var _this3 = this;

      (0, _mobx.transaction)(function () {
        var theField = _this3.getField(field);

        if (reset) {
          theField._skipValidation = true;
        }

        theField.value = value;

        if (reset) {
          theField.clearValidation();
          theField.clearInteractive();
          theField._skipValidation = false;
        }
      });
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      var _this4 = this;

      var keys = Object.keys(this.fields);
      return keys.reduce(function (seq, key) {
        var field = _this4.fields[key];
        seq[key] = field.value; // eslint-disable-line no-param-reassign
        return seq;
      }, {});
    }
  }, {
    key: 'valid',
    get: function get() {
      var _this5 = this;

      if (this.validating) {
        return false; // consider the form invalid until the validation process finish
      }
      var keys = Object.keys(this.fields);
      return keys.every(function (key) {
        var field = _this5.fields[key];
        return !!field.valid;
      }, true);
    }
  }, {
    key: 'interacted',
    get: function get() {
      var _this6 = this;

      var keys = this.fieldKeys();
      return keys.some(function (key) {
        var field = _this6.fields[key];
        return !!field.interacted;
      });
    }
  }, {
    key: 'summary',
    get: function get() {
      var _this7 = this;

      return this.fieldKeys().reduce(function (seq, key) {
        var field = _this7.fields[key];
        if (field.errorMessage) {
          seq.push(field.errorMessage);
        }
        return seq;
      }, []);
    }
  }]);

  function FormModel() {
    var _this8 = this;

    var initialState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var validators = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, FormModel);

    _initDefineProp(this, 'fields', _descriptor, this);

    _initDefineProp(this, 'validating', _descriptor2, this);

    var keys = Object.keys(initialState);

    keys.forEach(function (key) {
      (0, _mobx.extendObservable)(_this8.fields, _defineProperty({}, key, new _Field2.default(_this8, initialState[key], validators[key])));
    });
  }

  return FormModel;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'fields', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'validating', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'valid', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'valid'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'interacted', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'interacted'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'summary', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'summary'), _class.prototype)), _class);
function createModel(initialState, validators) {
  return new FormModel(initialState, validators);
}