'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactTinyVirtualList = require('react-tiny-virtual-list');

var _reactTinyVirtualList2 = _interopRequireDefault(_reactTinyVirtualList);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactScrollbarSize = require('react-scrollbar-size');

var _reactScrollbarSize2 = _interopRequireDefault(_reactScrollbarSize);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactContainerDimensions = require('react-container-dimensions');

var _GridRow = require('./GridRow');

var _GridRow2 = _interopRequireDefault(_GridRow);

var _GridTextBox = require('./GridTextBox');

var _GridTextBox2 = _interopRequireDefault(_GridTextBox);

var _GridHeader = require('./GridHeader');

var _GridHeader2 = _interopRequireDefault(_GridHeader);

var _GridTools = require('./GridTools');

var _GridTools2 = _interopRequireDefault(_GridTools);

var _reactTooltip = require('react-tooltip');

var _reactTooltip2 = _interopRequireDefault(_reactTooltip);

var _DatePickerOverlay = require('./easyTools/DatePickerOverlay');

var _DatePickerOverlay2 = _interopRequireDefault(_DatePickerOverlay);

var _MenuPickerOverlay = require('./easyTools/MenuPickerOverlay');

var _MenuPickerOverlay2 = _interopRequireDefault(_MenuPickerOverlay);

var _AltTextOverlay = require('./easyTools/AltTextOverlay');

var _AltTextOverlay2 = _interopRequireDefault(_AltTextOverlay);

var _EasyBool = require('./easyTools/EasyBool');

var _EasyBool2 = _interopRequireDefault(_EasyBool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

// Wrapper for the grid
// This grid allows deep styling via style objects, 
// but retains control of border and padding to ensure that the grid lines up.
var GridBody = (0, _mobxReact.observer)((_class = function (_React$Component) {
  _inherits(GridBody, _React$Component);

  function GridBody(props) {
    _classCallCheck(this, GridBody);

    var _this = _possibleConstructorReturn(this, (GridBody.__proto__ || Object.getPrototypeOf(GridBody)).call(this, props));

    _initDefineProp(_this, 'scrollBarWide', _descriptor, _this);

    (0, _reactAutobind2.default)(_this);
    _this.componentWillReceiveProps(props); // first call needs to set up the data store
    return _this;
  }

  _createClass(GridBody, [{
    key: 'setScrollBarWide',
    // keep track of how wide the scroll bar will be
    value: function setScrollBarWide(exp) {
      this.props.GridStore.scrollBarWide = exp.scrollbarWidth + 2;
    } // account for rounding error

    // prep the data store

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.debugGridMath) {
        console.log('componentWillReceiveProps');
      }

      if (this.props.GridStore) {
        this.props.GridStore.prepSelectionField(nextProps);
      } else {
        console.log('missing grid store');
      }
    }
  }, {
    key: 'blurControl',
    value: function blurControl(evt) {
      // brain dead LUCK is the only thing making this work.
      // when moving focus in the cell, it sets autoFocus true.
      // then it renders all the cells and one of them takes focus, focusing the new cell and bluring the old one.
      // the blur event comes here and tells us to not steal focus any more.
      // Now we can type into other things all day.  But only if we click into a cell will the focus move with us.  Lucky!
      this.props.GridStore.autoFocus = false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this,
          _ref2,
          _extends2;

      // do a bunch of math to figure out where things should go.
      var ui = this.props.GridStore.uiMath;

      // log what we're doing if asked to
      if (this.props.debugGridMath) {
        console.log('render grid');
        console.log(ui);
      }

      // text view
      if (this.props.editAsText) {
        return _react2.default.createElement(_GridTextBox2.default, _extends({}, this.props, { uiMath: ui })); // forget this complex grid nonsense.  Just make a big text area and edit the stuff that way.
      }

      // error view
      if (ui.notReady) {
        return (// something isn't ready.   Just drop an error and move on.
          _react2.default.createElement(
            'div',
            { style: { backgroundColor: '#ffcea0', outline: '4px dashed red', padding: '5px' } },
            _react2.default.createElement(_reactScrollbarSize2.default, {
              onLoad: this.setScrollBarWide,
              onChange: this.setScrollBarWide
            }),
            'Sorry, this grid is not ready to display.',
            _react2.default.createElement('br', null),
            _react2.default.createElement('br', null),
            ui.notReady
          )
        );
      }

      // the real stuff.  Release the Kraken...  I mean the Grid.
      return _react2.default.createElement(
        'div',
        { style: _extends({}, this.props.style, {
            height: ui.gridHigh,
            width: ui.gridWide }),
          onKeyPress: this.onKeyPress, onBlur: this.blurControl, key: 'scrollSize' },
        _react2.default.createElement(_reactScrollbarSize2.default, { onLoad: this.setScrollBarWide, onChange: this.setScrollBarWide }),
        _react2.default.createElement(_GridHeader2.default, _extends({ uiMath: ui }, this.props)),
        (this.props.GridStore.showDatePicker || this.props.GridStore.showDateTimePicker) && _react2.default.createElement(_DatePickerOverlay2.default, { GridStore: this.props.GridStore, uiMath: ui }),
        this.props.GridStore.showMenuPicker && _react2.default.createElement(_MenuPickerOverlay2.default, { GridStore: this.props.GridStore, uiMath: ui }),
        _react2.default.createElement(_AltTextOverlay2.default, { GridStore: this.props.GridStore, uiMath: ui }),
        _react2.default.createElement(_reactTinyVirtualList2.default, {
          width: ui.gridWide,
          height: ui.dataAvailableHigh,
          itemCount: ui.fixedRowCount,
          itemSize: ui.rowHighWithPad + ui.borderWide,
          renderItem: function renderItem(_ref) {
            var index = _ref.index,
                style = _ref.style;
            return _react2.default.createElement(
              'div',
              { key: index, style: style },
              _react2.default.createElement(_GridRow2.default, { data: _this2.props.data,
                GridStore: _this2.props.GridStore,
                styleInput: _this2.props.styleInput,
                styleCell: _this2.props.styleCell,
                styleHeader: _this2.props.styleHeader,
                styleRowHeader: _this2.props.styleRowHeader,
                uiMath: ui,
                pivotOn: _this2.props.pivotOn,
                onChange: _this2.props.onChange,
                index: index
              })
            );
          }
        }),
        this.props.gridHighCollapse === false && ui.collapseAvailable > 0 && _react2.default.createElement('div', { style: (_ref2 = {
            minWidth: ui.rowWide
          }, _defineProperty(_ref2, 'minWidth', ui.rowWide), _defineProperty(_ref2, 'width', ui.rowWide), _defineProperty(_ref2, 'marginTop', -1 * ui.borderWide), _defineProperty(_ref2, 'height', ui.collapseAvailable), _defineProperty(_ref2, 'minHeight', ui.collapseAvailable), _defineProperty(_ref2, 'borderStyle', 'solid'), _defineProperty(_ref2, 'borderLeftWidth', ui.borderWide), _defineProperty(_ref2, 'borderRightWidth', ui.borderWide), _defineProperty(_ref2, 'borderBottomWidth', ui.borderWide), _defineProperty(_ref2, 'borderTopWidth', 0), _defineProperty(_ref2, 'borderColor', 'black'), _defineProperty(_ref2, 'backgroundColor', 'white'), _ref2) }),
        ui.showBottomGridLine && // needs the 2x border wide added because this is only a top border
        _react2.default.createElement('div', { style: _extends({}, this.props.styleHeader, (_extends2 = {
            width: ui.rowWide + 2 * ui.borderWide,
            minWidth: ui.rowWide + 2 * ui.borderWide
          }, _defineProperty(_extends2, 'width', ui.rowWide + 2 * ui.borderWide), _defineProperty(_extends2, 'borderTopStyle', 'solid'), _defineProperty(_extends2, 'borderTopWidth', ui.borderWide), _defineProperty(_extends2, 'height', '0px'), _extends2)) }),
        _react2.default.createElement(_GridTools2.default, _extends({}, this.props, { uiMath: ui }))
      );
    }
  }]);

  return GridBody;
}(_react2.default.Component), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'scrollBarWide', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return 0;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'setScrollBarWide', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setScrollBarWide'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'blurControl', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'blurControl'), _class.prototype)), _class));

exports.default = GridBody;
module.exports = exports['default'];