'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _desc, _value, _class2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactTinyVirtualList = require('react-tiny-virtual-list');

var _reactTinyVirtualList2 = _interopRequireDefault(_reactTinyVirtualList);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactScrollbarSize = require('react-scrollbar-size');

var _reactScrollbarSize2 = _interopRequireDefault(_reactScrollbarSize);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactContainerDimensions = require('react-container-dimensions');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _accounting = require('accounting');

var _accounting2 = _interopRequireDefault(_accounting);

var _reactDatepicker = require('react-datepicker');

var _reactDatepicker2 = _interopRequireDefault(_reactDatepicker);

require('react-datepicker/dist/react-datepicker.css');

var _EasyBool = require('./easyTools/EasyBool');

var _EasyBool2 = _interopRequireDefault(_EasyBool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

window.reactJsonGridFocusInput = function (elem) {
  elem.focus();
  elem.setSelectionRange(elem.value.length, elem.value.length);
};

var GridCell = (0, _mobxReact.observer)(_class = (_class2 = function (_React$Component) {
  _inherits(GridCell, _React$Component);

  function GridCell(props) {
    _classCallCheck(this, GridCell);

    var _this = _possibleConstructorReturn(this, (GridCell.__proto__ || Object.getPrototypeOf(GridCell)).call(this, props));

    (0, _reactAutobind2.default)(_this);return _this;
  }

  _createClass(GridCell, [{
    key: 'isEditDisabled',
    value: function isEditDisabled() {
      var ed = this.props.uiMath.editDisabled === true;
      if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && // edit disabled by column
      this.props.GridStore.colDefListByKey[this.props.objKey].editDisabled === true) {
        ed = true;
      }
      return ed;
    }
  }, {
    key: 'onClick',
    value: function onClick(evt) {
      this.props.GridStore.autoFocus = true; // if we edit, auto focus.

      if (this.props.x === this.props.GridStore.cursor.x && // clicked the currently highlighted cell
      this.props.y === this.props.GridStore.cursor.y && // clicked the currently highlighted cell
      this.isEditDisabled() === false // edit is allowable
      ) {
          this.props.GridStore.cursor.editX = this.props.x;
          this.props.GridStore.cursor.editY = this.props.y;
          this.props.GridStore.cursor.editObjKey = this.props.objKey;
          this.props.GridStore.curEditingValue = this.props.cellData;

          // check for dates and menus
          if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDate) {
            this.props.GridStore.showDatePicker = true;
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDateTime) {
            this.props.GridStore.showDateTimePicker = true;
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyMenu) {
            this.props.GridStore.showMenuPicker = true;
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].overlayComp) {
            this.props.GridStore.showOverlayComp = true;
          }
        } else {
        this.props.GridStore.cursor.x = this.props.x;
        this.props.GridStore.cursor.y = this.props.y;
        if (this.props.GridStore.cursor.x < 0) {
          this.props.GridStore.cursor.x = 0;
        } // can't edit row headers
      }
    }
  }, {
    key: 'onKeyDownWhenViewing',
    value: function onKeyDownWhenViewing(e) {
      this.props.GridStore.autoFocus = true; // if we edit, auto focus it.

      var editDisabled = this.isEditDisabled();

      if (this.props.x !== this.props.GridStore.cursor.editX || this.props.y !== this.props.GridStore.cursor.editY) {
        if (e.keyCode == '37' || e.keyCode == '38' || e.keyCode == '39' || e.keyCode == '40') {
          // arrows
          this.props.GridStore.cellMoveKey(e);
        } else if (e.keyCode == '13') {
          // enter
          if (e.shiftKey) {
            // back-enter
            this.props.GridStore.cursor.y--;
            if (this.props.GridStore.cursor.y < 0) {
              this.props.GridStore.cursor.y = 0;
            }
          } else {
            // forward-enter
            this.props.GridStore.cursor.y++;
            if (this.props.GridStore.cursor.y > this.props.GridStore.cursor.maxY) {
              this.props.GridStore.cursor.y = 0;
            }
          }
        } else if (e.keyCode == '9') {
          // tab
          if (e.shiftKey) {
            // back tab
            this.props.GridStore.cursor.x--;
            if (this.props.GridStore.cursor.x < 0) {
              this.props.GridStore.cursor.x = this.props.GridStore.cursor.maxX;
              this.props.GridStore.cursor.y--;
            }
            if (this.props.GridStore.cursor.y < 0) {
              this.props.GridStore.cursor.y = 0;
            }
          } else {
            // forward tab
            this.props.GridStore.cursor.x++;
            if (this.props.GridStore.cursor.x > this.props.GridStore.cursor.maxX) {
              this.props.GridStore.cursor.x = 0;
              this.props.GridStore.cursor.y++;
            }
            if (this.props.GridStore.cursor.y > this.props.GridStore.cursor.maxY) {
              this.props.GridStore.cursor.y = 0;
            }
          }
        } else if (e.keyCode == '32' && editDisabled === false) {
          // space
          // cell edit
          this.props.GridStore.cursor.editX = this.props.x;
          this.props.GridStore.cursor.editY = this.props.y;
          this.props.GridStore.cursor.editObjKey = this.props.objKey;
          this.props.GridStore.curEditingValue = this.props.GridStore.getDataRespectingPivotAtEditCursor(this.props.data);
          // pop overlay editors if needed
          if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDate) {
            this.props.GridStore.showDatePicker = true;
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDateTime) {
            this.props.GridStore.showDateTimePicker = true;
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyMenu) {
            this.props.GridStore.showMenuPicker = true;
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].overlayComp) {
            this.props.GridStore.showOverlayComp = true;
          }
        } else if (e.keyCode == '46' && editDisabled === false) {
          // delete: instant kill!
          this.props.GridStore.onChangePivotWrapper(this.props.x, this.props.y, this.props.objKey, '');
        } else {
          if (e.key.length === 1 && editDisabled === false) {
            // must be a char
            // not that the react code calls a javascript function to make sure the cursor goes to the end of the input so you can keep typing naturally.
            this.props.GridStore.cursor.editX = this.props.x;
            this.props.GridStore.cursor.editY = this.props.y;
            this.props.GridStore.cursor.editObjKey = this.props.objKey;
            if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDate) {
              this.props.GridStore.showDatePicker = true;
            } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDateTime) {
              this.props.GridStore.showDateTimePicker = true;
            } else {
              this.props.GridStore.curEditingValue = '' + e.key;
            }
          }
        }
      }
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: 'valChange',
    value: function valChange(evt) {
      this.props.GridStore.curEditingValue = evt.target.value;
    }
  }, {
    key: 'valChangeDate',
    value: function valChangeDate(value) {
      this.props.GridStore.curEditingValue = value;
    }
  }, {
    key: 'endEdit',
    value: function endEdit() {
      if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey]) {
        if (this.props.GridStore.colDefListByKey[this.props.objKey].easyInt && !this.props.GridStore.curEditIsValidFor.isValidInt || this.props.GridStore.colDefListByKey[this.props.objKey].easyFloat && !this.props.GridStore.curEditIsValidFor.isValidFloat || (this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyDollar || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyEuro || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyPound) && !this.props.GridStore.curEditIsValidFor.isValidFloat) {
          // value is not valid for the field definition.  Do not make the change.
          this.props.GridStore.cursor.editX = -1;
          this.props.GridStore.cursor.editY = -1;
          return;
        }
      }

      this.props.GridStore.onChangePivotWrapper(this.props.x, this.props.y, this.props.objKey, this.props.GridStore.curEditingValue);
      this.props.GridStore.cursor.editX = -1;
      this.props.GridStore.cursor.editY = -1;
    }
  }, {
    key: 'onKeyDownWhenEditing',
    value: function onKeyDownWhenEditing(e) {

      if (e.keyCode == '13') {
        // commit the value
        this.endEdit();
        // move the cursor
        if (e.shiftKey) {
          // back-enter
          this.props.GridStore.cursor.y--;
          if (this.props.GridStore.cursor.y < 0) {
            this.props.GridStore.cursor.y = 0;
          }
        } else {
          // forward-enter
          this.props.GridStore.cursor.y++;
          if (this.props.GridStore.cursor.y > this.props.GridStore.cursor.maxY) {
            this.props.GridStore.cursor.y = 0;
          }
        }

        // start editing new location
        this.props.GridStore.cursor.editX = this.props.GridStore.cursor.x;
        this.props.GridStore.cursor.editY = this.props.GridStore.cursor.y;
        this.props.GridStore.curEditingValue = this.props.GridStore.getDataRespectingPivotAtEditCursor(this.props.data);
      } else if (e.keyCode == '9') {
        // tab
        // commit the value
        this.endEdit();

        // move the cursor
        if (e.shiftKey) {
          // back tab
          this.props.GridStore.cursor.x--;
          if (this.props.GridStore.cursor.x < 0) {
            this.props.GridStore.cursor.x = this.props.GridStore.cursor.maxX;
            this.props.GridStore.cursor.y--;
          }
          if (this.props.GridStore.cursor.y < 0) {
            this.props.GridStore.cursor.y = 0;
          }
        } else {
          // forward tab
          this.props.GridStore.cursor.x++;
          if (this.props.GridStore.cursor.x > this.props.GridStore.cursor.maxX) {
            this.props.GridStore.cursor.x = 0;
            this.props.GridStore.cursor.y++;
          }
          if (this.props.GridStore.cursor.y > this.props.GridStore.cursor.maxY) {
            this.props.GridStore.cursor.y = 0;
          }
        }

        // start editing the next one
        this.props.GridStore.cursor.editX = this.props.GridStore.cursor.x;
        this.props.GridStore.cursor.editY = this.props.GridStore.cursor.y;
        this.props.GridStore.curEditingValue = this.props.GridStore.getDataRespectingPivotAtEditCursor(this.props.data);
        this.props.GridStore.autoFocus = true;
        e.stopPropagation();
        e.preventDefault();
      } else if (e.keyCode == '27') {
        // cell edit abort
        this.props.GridStore.cursor.editX = -1;
        this.props.GridStore.cursor.editY = -1;
      }
    }
  }, {
    key: 'renderZero',
    value: function renderZero(tval) {
      if (0 === tval) {
        return '0';
      } else if ('false' === '' + tval) {
        return 'false';
      } else if ('true' === '' + tval) {
        return 'true';
      } else {
        return tval;
      }
    }
  }, {
    key: 'render',
    value: function render() {

      var style = _extends({}, this.props.styleCell, { boxSizing: 'content-box' });
      var styleIn = _extends({}, this.props.styleInput, { boxSizing: 'content-box' });

      if (this.props.GridStore.selectionBounds.l <= this.props.x && this.props.GridStore.selectionBounds.r >= this.props.x && this.props.GridStore.selectionBounds.t <= this.props.y && this.props.GridStore.selectionBounds.b >= this.props.y) {
        // CSSNOTE!
        style = _extends({ backgroundColor: 'lightblue' }, style, this.props.GridStore.styleSelectedCell);
        style.zIndex = 5;
      }

      if (!this.props.isFirstColumn) {
        style.marginLeft = -1 * this.props.uiMath.borderWide;
        styleIn.marginLeft = -1 * this.props.uiMath.borderWide;
      } else {
        style.marginLeft = 0;
        styleIn.marginLeft = 0;
      }

      // over ride width if needed
      if (this.props.GridStore.colDefListByKey[this.props.objKey]) {
        // is there a colDef that uses this key?
        var curColWide = style.width;
        if (this.props.GridStore.colDefListByKey[this.props.objKey].forceColWide) {
          curColWide = this.props.GridStore.colDefListByKey[this.props.objKey].forceColWide;
        }
        style.width = curColWide;
      }

      // render data standard
      var renderPlan = '';
      var isFocusNeeded = this.props.GridStore.autoFocus && this.props.x === this.props.GridStore.cursor.x && this.props.y === this.props.GridStore.cursor.y;

      var assumeEditOk = true;
      if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && (this.props.GridStore.colDefListByKey[this.props.objKey].easyBool === true || // boolean doesn't need the editor
      this.props.GridStore.colDefListByKey[this.props.objKey].easyMenu === true) // menu doesn't need the editor
      ) {
          assumeEditOk = false;
        }
      if (this.isEditDisabled()) {
        assumeEditOk = false;
      }

      if (assumeEditOk && this.props.x === this.props.GridStore.cursor.x && // cur render cell is cur cell  
      this.props.y === this.props.GridStore.cursor.y && // cur render cell is cur cell
      this.props.x === this.props.GridStore.cursor.editX && // cur cell is edit cell
      this.props.y === this.props.GridStore.cursor.editY // cur cell is edit cell
      ) {
          styleIn.verticalAlign = 'top';
          styleIn.width = style.width; // use the column defined width override if needed.

          // check for easy column tools
          if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey]) {

            // check validation
            if (this.props.GridStore.colDefListByKey[this.props.objKey].easyInt && !this.props.GridStore.curEditIsValidFor.isValidInt || this.props.GridStore.colDefListByKey[this.props.objKey].easyFloat && !this.props.GridStore.curEditIsValidFor.isValidFloat || (this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyDollar || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyEuro || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyPound) && !this.props.GridStore.curEditIsValidFor.isValidFloat) {
              styleIn.outline = "5px red dashed";
            }

            // check right alignment
            if (this.props.GridStore.colDefListByKey[this.props.objKey].easyInt || this.props.GridStore.colDefListByKey[this.props.objKey].easyFloat || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyDollar || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyEuro || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyPound) {
              styleIn.textAlign = "right";
            }
          }

          var curDisplayVal = this.props.GridStore.curEditingValue;
          if (null === curDisplayVal) {
            curDisplayVal = this.props.cellData;
          }

          // check for easy Date
          if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDate) {
            renderPlan = _react2.default.createElement(
              'div',
              { style: styleIn },
              curDisplayVal
            );
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyDateTime) {
            renderPlan = _react2.default.createElement(
              'div',
              { style: styleIn },
              curDisplayVal
            );
          } else if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey] && this.props.GridStore.colDefListByKey[this.props.objKey].easyMenu) {
            renderPlan = _react2.default.createElement(
              'div',
              { style: styleIn },
              curDisplayVal
            );
          } else {
            // use the normal text input editor  
            renderPlan = _react2.default.createElement('input', { value: curDisplayVal,
              onChange: this.valChange,
              onKeyDown: this.onKeyDownWhenEditing,
              id: this.props.id, style: styleIn,
              ref: function ref(input) {
                return input && window.reactJsonGridFocusInput(input);
              },
              onBlur: this.endEdit
            });
          }
        } else {
        //===== VIEW SIDE

        var renderVal = '' + (this.renderZero(this.props.cellData) || '');
        if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[this.props.objKey]) {
          // we have a custom view component.  Render it.
          // it may want to change values directly, so give it everything it needs

          var styleByCol = {};
          if (this.props.x >= 0) {
            styleByCol = this.props.GridStore.colDefListByKey[this.props.objKey].styleCell || {};
          }

          // check right alignment
          if (this.props.GridStore.colDefListByKey[this.props.objKey].easyInt || this.props.GridStore.colDefListByKey[this.props.objKey].easyFloat || this.props.GridStore.colDefListByKey[this.props.objKey].easyDate || this.props.GridStore.colDefListByKey[this.props.objKey].easyDateTime || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyDollar || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyEuro || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyPound) {
            style.textAlign = "right";
            // check validation
            if (this.props.GridStore.colDefListByKey[this.props.objKey].easyInt && !this.props.GridStore.checkValidInt(this.props.cellData) || this.props.GridStore.colDefListByKey[this.props.objKey].easyFloat && !this.props.GridStore.checkValidFloat(this.props.cellData) || (this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyDollar || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyEuro || this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyPound) && !this.props.GridStore.checkValidFloat(this.props.cellData)) {
              style.outline = "3px orange dashed";
            }

            // since we're here: format the money:
            if (this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyDollar) {
              renderVal = _accounting2.default.formatMoney(this.props.cellData, "$", 2, ",", ".");
            } else if (this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyEuro) {
              renderVal = _accounting2.default.formatMoney(this.props.cellData, "€", 2, ".", ",");
            } else if (this.props.GridStore.colDefListByKey[this.props.objKey].easyMoneyPound) {
              renderVal = _accounting2.default.formatMoney(this.props.cellData, "£", 2, ".", ",");
            }
            // since we're here: highlight invalid dates & times
            if (this.props.GridStore.colDefListByKey[this.props.objKey].easyDate) {
              var parsed = (0, _moment2.default)(this.props.cellData, this.props.uiMath.formatDate);
              if (!parsed.isValid) {
                style.outline = "3px orange dashed";
              } else {
                renderVal = parsed.format(this.props.uiMath.formatDate);
              }
            } else if (this.props.GridStore.colDefListByKey[this.props.objKey].easyDateTime) {
              var parsed = (0, _moment2.default)(this.props.cellData, this.props.uiMath.formatDate + ' ' + this.props.uiMath.formatTime);
              if (!parsed.isValid) {
                style.outline = "3px orange dashed";
              } else {
                renderVal = parsed.format(this.props.uiMath.formatDate + ' ' + this.props.uiMath.formatTime);
              }
            }
          }

          // check for custom renders
          if (this.props.GridStore.colDefListByKey[this.props.objKey].compCell) {
            renderVal = _react2.default.createElement(
              'span',
              null,
              _react2.default.cloneElement(this.props.GridStore.colDefListByKey[this.props.objKey].compCell, {
                x: this.props.GridStore.pivotOn ? this.props.y : this.props.x,
                y: this.props.GridStore.pivotOn ? this.props.x : this.props.x,
                objKey: this.props.objKey,
                cellData: this.props.cellData,
                id: this.props.id + '-comp',
                onChange: this.props.onChange
              })
            );
          }

          // handle easyBool
          if (this.props.GridStore.colDefListByKey[this.props.objKey].easyBool) {

            var disableEdit = this.isEditDisabled();

            renderVal = _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement(_EasyBool2.default, {
                x: this.props.GridStore.pivotOn ? this.props.y : this.props.x,
                y: this.props.GridStore.pivotOn ? this.props.x : this.props.y,
                objKey: this.props.objKey,
                cellData: this.props.cellData,
                id: this.props.id + '-comp',
                disabled: disableEdit,
                onChange: this.props.GridStore.onChange })
            );
          }
        }

        var cellClassName = '';
        var dataClassName = '';
        if (this.props.x === -1) {
          // this is a row header.  Precedence is classNameHeaderCell, classNameHeaderRowCell
          cellClassName = (this.props.GridStore.classNameHeaderCell || '') + ' ' + (this.props.GridStore.classNameHeaderRowCell || '');
          dataClassName = (this.props.GridStore.classNameHeaderData || '') + ' ' + (this.props.GridStore.classNameHeaderRowData || '');

          if (!this.props.GridStore.classNameHeaderCell && !this.props.GridStore.classNameHeaderRowCell) {
            if (!style.backgroundColor && (!styleByCol || !styleByCol.backgroundColor)) {
              style.backgroundColor = '#F3F3F3';
            }
            if (!style.textAlign && (!styleByCol || !styleByCol.textAlign)) {
              style.textAlign = 'center';
            }
          }

          var rowKey = this.props.uiMath.rowHeaderList[this.props.y];
          if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[rowKey]) {
            cellClassName = cellClassName + ' ' + (this.props.GridStore.colDefListByKey[rowKey].classNameHeaderCell || '');
            dataClassName = dataClassName + ' ' + (this.props.GridStore.colDefListByKey[rowKey].classNameHeaderData || '');
            console.log(cellClassName);
            console.log(dataClassName);
          }
        }

        renderPlan = _react2.default.createElement(
          'div',
          { tabIndex: '0',
            className: cellClassName,
            onClick: this.onClick,
            id: this.props.id, style: _extends({}, style, styleByCol),
            ref: function ref(div) {
              return div && isFocusNeeded && div.focus();
            },
            onKeyDown: this.onKeyDownWhenViewing },
          _react2.default.createElement(
            'div',
            { className: dataClassName },
            renderVal
          )
        );
      }

      return renderPlan;
    }
  }]);

  return GridCell;
}(_react2.default.Component), (_applyDecoratedDescriptor(_class2.prototype, 'isEditDisabled', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'isEditDisabled'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onClick', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onClick'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onKeyDownWhenViewing', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onKeyDownWhenViewing'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'valChange', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'valChange'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'valChangeDate', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'valChangeDate'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'endEdit', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'endEdit'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onKeyDownWhenEditing', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onKeyDownWhenEditing'), _class2.prototype)), _class2)) || _class;

exports.default = GridCell;
module.exports = exports['default'];