'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactTooltip = require('react-tooltip');

var _reactTooltip2 = _interopRequireDefault(_reactTooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GridHeader = (0, _mobxReact.observer)(_class = function (_React$Component) {
  _inherits(GridHeader, _React$Component);

  function GridHeader(props) {
    _classCallCheck(this, GridHeader);

    var _this = _possibleConstructorReturn(this, (GridHeader.__proto__ || Object.getPrototypeOf(GridHeader)).call(this, props));

    (0, _reactAutobind2.default)(_this);return _this;
  }

  _createClass(GridHeader, [{
    key: 'render',
    value: function render() {

      var header = [];
      var marginOffset = 0;
      var ui = this.props.uiMath;

      if (!this.props.colHeaderHide && !ui.forceColHeaderHide) {
        // provide a header row.
        for (var ctr = 0; ctr < ui.colHeaderKeyList.length; ctr++) {

          var keyName = ui.colHeaderKeyList[ctr]; // what key am I on?
          var colTitle = keyName;
          var curColWide = ui.autoColWide;
          var gridColLocalStyle = {};
          var helpComp = null;
          if (this.props.GridStore.colDefListByKey[keyName]) {
            // is there a colDef that uses this key?
            if (this.props.pivotOn) {
              //== Pivot, With ColDefs
              if (ctr > 0) {
                if (this.props.GridStore.colDefListByKey[this.props.GridStore.keyList[ctr - 1]].altText) {
                  helpComp = this.props.GridStore.colDefListByKey[this.props.GridStore.keyList[ctr - 1]].altText;
                }
              }
              var targetCol = 0;
              for (var tctr = 0; tctr < ui.colHeaderKeyList.length; tctr++) {
                if (ui.colHeaderKeyList[tctr] === this.props.pivotOn) {
                  targetCol = tctr;
                } // this is the header index matching the pivotOn key, offset by 1 due to leading '/'
              }
              colTitle = this.props.GridStore.getDataRespectingPivotAtLocation(this.props.data, ctr - 1, targetCol - 1); // both -1 are to account for the '/' in the header row.
            } else {
              //== NonPivot, With ColDefs
              gridColLocalStyle = this.props.GridStore.colDefListByKey[keyName].styleHeader || {};
              if (this.props.GridStore.colDefListByKey[keyName].widePx) {
                // width by px
                curColWide = this.props.GridStore.colDefListByKey[keyName].widePx;
              } else if (this.props.GridStore.colDefListByKey[keyName].widePct) {
                // width by pct
                curColWide = ui.rowWide * (this.props.GridStore.colDefListByKey[keyName].widePct / 100);
              }

              colTitle = this.props.GridStore.colDefListByKey[keyName].title || keyName; // if there is a title for the colDef use it, or just stick with thekey
              if (this.props.GridStore.colDefListByKey[keyName].altText) {
                // handle alt text.  Note that the 'text' could be a component.  regular header
                helpComp = this.props.GridStore.colDefListByKey[keyName].altText;
              }
            }
          } else {
            if (this.props.pivotOn) {
              // no column defs, Pivot On
              if (ctr > 0) {
                // find the index of the colDefListByKey item for the pivotOn target:
                var targetCol = 0;
                for (var tctr = 0; tctr < ui.colHeaderKeyList.length; tctr++) {
                  if (ui.colHeaderKeyList[tctr] === this.props.pivotOn) {
                    targetCol = tctr;
                  } // this is the header index matching the pivotOn key, offset by 1 due to leading '/'
                }
                colTitle = this.props.GridStore.getDataRespectingPivotAtLocation(this.props.data, ctr - 1, targetCol - 1); // both -1 are to account for the '/' in the header row.
              }
            } else {
              // no column defs, Pivot OFF
              if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[keyName] && this.props.GridStore.colDefListByKey[keyName].altText) {
                helpComp = this.props.GridStore.colDefListByKey[keyName].altText;
              }
            }
          }

          // NOTE: check for header components here.
          if (ctr === 0 && this.props.pivotOn && ui.pivotRowHeaderWide) {
            curColWide = Number(ui.pivotRowHeaderWide);
          }

          var classNameHeaderColData = '';
          var classNameHeaderColCell = '';
          if (this.props.GridStore.colDefListByKey && this.props.GridStore.colDefListByKey[keyName]) {
            if (this.props.GridStore.colDefListByKey[keyName].forceColWide) {
              curColWide = this.props.GridStore.colDefListByKey[keyName].forceColWide;
            }
            if (!this.props.pivotOn) {
              classNameHeaderColData = this.props.GridStore.colDefListByKey[keyName].classNameHeaderData || '';
              classNameHeaderColCell = this.props.GridStore.colDefListByKey[keyName].classNameHeaderCell || '';
            }
          }

          var defaultStyle = this.props.styleHeader || {};
          if (!this.props.classNameHeaderCell) {
            defaultStyle = { backgroundColor: '#F3F3F3', textAlign: 'center' }; // so it can be over-ridden by the class if supplied.
          }

          header.push(_react2.default.createElement(
            'a',
            { 'data-tip': true, 'data-for': 'dataTip' + ctr, key: ctr // default, may be over ridden by styleHeader. Order matters.
            },
            _react2.default.createElement(
              'div',
              { key: 'k' + ctr, className: this.props.classNameHeaderCell + ' ' + classNameHeaderColCell,
                style: _extends({}, defaultStyle, gridColLocalStyle, { // user specified per-column header styles.
                  width: curColWide, // everything from here down cannot be over-ridden by the user.
                  maxWidth: curColWide, // everything from here down cannot be over-ridden by the user.
                  borderStyle: 'solid',
                  borderWidth: ui.borderWide,
                  padding: ui.padWide + 'px',
                  display: 'inline-block',
                  marginLeft: marginOffset,
                  overflow: 'hidden',
                  boxSizing: 'content-box',
                  height: ui.colHeaderHigh + 'px',
                  maxHeight: ui.colHeaderHigh + 'px' }) },
              _react2.default.createElement(
                'div',
                { className: this.props.classNameHeaderData + ' ' + classNameHeaderColData },
                colTitle
              ),
              helpComp && // only render this if helpComp is defined
              _react2.default.createElement(
                _reactTooltip2.default,
                { id: 'dataTip' + ctr },
                helpComp
              )
            )
          ));
          marginOffset = -1 * ui.borderWide;
        }
      } else {
        // header is hidden so provide a top border line.  The 2x borderWide extra width is needed because this is a top only border
        if (!ui.forceColHeaderHide) {
          var _extends2;

          header.push(_react2.default.createElement('div', { style: _extends({
              key: 'headerLine'
            }, this.props.styleHeader, (_extends2 = {
              width: ui.rowWide + 2 * ui.borderWide,
              minWidth: ui.rowWide + 2 * ui.borderWide
            }, _defineProperty(_extends2, 'width', ui.rowWide + 2 * ui.borderWide), _defineProperty(_extends2, 'borderTopStyle', 'solid'), _defineProperty(_extends2, 'borderTopWidth', ui.borderWide), _defineProperty(_extends2, 'height', '0px'), _extends2)) }));
        }
      }

      return _react2.default.createElement(
        'div',
        { style: { padding: '0px', margin: '0px', maxHeight: '' + ui.headerUsage + 'px', minHeight: '' + ui.headerUsage + 'px', height: '' + ui.headerUsage + 'px' } },
        header
      );
    }
  }]);

  return GridHeader;
}(_react2.default.Component)) || _class;

exports.default = GridHeader;
module.exports = exports['default'];