'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactTinyVirtualList = require('react-tiny-virtual-list');

var _reactTinyVirtualList2 = _interopRequireDefault(_reactTinyVirtualList);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactScrollbarSize = require('react-scrollbar-size');

var _reactScrollbarSize2 = _interopRequireDefault(_reactScrollbarSize);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactContainerDimensions = require('react-container-dimensions');

var _GridCell = require('./GridCell');

var _GridCell2 = _interopRequireDefault(_GridCell);

var _reactTooltip = require('react-tooltip');

var _reactTooltip2 = _interopRequireDefault(_reactTooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GridRow = (0, _mobxReact.observer)(_class = function (_React$Component) {
  _inherits(GridRow, _React$Component);

  function GridRow(props) {
    _classCallCheck(this, GridRow);

    var _this = _possibleConstructorReturn(this, (GridRow.__proto__ || Object.getPrototypeOf(GridRow)).call(this, props));

    (0, _reactAutobind2.default)(_this);return _this;
  }

  _createClass(GridRow, [{
    key: 'showRowHeaderAltText',
    value: function showRowHeaderAltText(e, x, y) {
      this.props.GridStore.cursor.showAltX = x;
      this.props.GridStore.cursor.showAltY = y;
    }
  }, {
    key: 'hideRowHeaderAltText',
    value: function hideRowHeaderAltText(e, x, y) {
      if (this.props.GridStore.cursor.showAltX === x && this.props.GridStore.cursor.showAltY === y) {
        this.props.GridStore.cursor.showAltX = -1; // don't mess with it if values were set by someone else.
        this.props.GridStore.cursor.showAltY = -1;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var selRow = false;
      if (this.props.GridStore.cursor.y === this.props.index) {
        selRow = true;
      }

      var cellArray = [];
      var marginOffset = Math.floor(-1 * this.props.uiMath.borderWide);

      var topBorder = this.props.colHeaderHide || this.props.uiMath.forceColHeaderHide ? this.props.uiMath.borderWide : 0;

      var sharedBaseStyleLeftCol = {
        width: this.props.uiMath.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        padding: (this.props.uiMath.padWide || 0) + 'px',
        borderLeftWidth: this.props.uiMath.borderWide,
        borderRightWidth: this.props.uiMath.borderWide,
        borderBottomWidth: this.props.uiMath.borderWide,
        borderTopWidth: topBorder,
        height: this.props.uiMath.rowHighNoPad,
        display: 'inline-block',
        outline: outline,
        overflow: 'hidden'
      };

      var sharedBaseStyleInput = { width: this.props.uiMath.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        borderLeftWidth: this.props.uiMath.borderWide,
        borderRightWidth: this.props.uiMath.borderWide,
        borderBottomWidth: this.props.uiMath.borderWide,
        borderTopWidth: topBorder,
        backgroundColor: '#fffef4',
        padding: (this.props.uiMath.padWide || 0) + 'px',
        height: this.props.uiMath.rowHighNoPad,
        display: 'inline-block',
        outline: outline,
        marginLeft: marginOffset,
        overflow: 'hidden'
      };
      var sharedBaseStyle2 = { width: this.props.uiMath.autoColWide,
        borderStyle: 'solid',
        borderColor: 'black',
        borderLeftWidth: this.props.uiMath.borderWide,
        borderRightWidth: this.props.uiMath.borderWide,
        borderBottomWidth: this.props.uiMath.borderWide,
        borderTopWidth: topBorder,
        padding: (this.props.uiMath.padWide || 0) + 'px',
        height: this.props.uiMath.rowHighNoPad,
        display: 'inline-block',
        outline: outline,
        marginLeft: marginOffset,
        overflow: 'hidden'
      };

      var cellStyleFirst = Object.assign(sharedBaseStyleLeftCol, this.props.styleCell || {});
      var cellStyleLocal = Object.assign(sharedBaseStyle2, this.props.styleCell || {});

      var inputStyleFirst = Object.assign(sharedBaseStyleLeftCol, this.props.styleCell || {});
      var inputStyleLocal = Object.assign(sharedBaseStyleInput, this.props.styleInput || {});

      var keyName = null; // used for pivoted data only

      var columnCount = this.props.GridStore.cursor.maxX + 1;
      if (this.props.pivotOn) {
        columnCount = this.props.data.length;
      }
      var isFirst = true;
      for (var ctr = -1; ctr < columnCount; ctr++) {
        var borderColor = 'black';
        var zIndex = 0;
        var outline = '';

        cellStyleLocal.marginLeft = marginOffset + 'px';

        // row header / pivot work
        if (ctr === -1) {
          cellStyleFirst = { width: this.props.uiMath.autoColWide,
            borderStyle: 'solid',
            borderColor: 'black',
            padding: (this.props.uiMath.padWide || 0) + 'px',
            borderLeftWidth: this.props.uiMath.borderWide,
            borderRightWidth: this.props.uiMath.borderWide,
            borderBottomWidth: this.props.uiMath.borderWide,
            borderTopWidth: topBorder,
            height: this.props.uiMath.rowHighNoPad,
            display: 'inline-block',
            outline: outline,
            overflow: 'hidden' }; // don't add global cell style on row headers

          if (this.props.uiMath.rowHeaderList && this.props.uiMath.rowHeaderList.length > this.props.index) {
            var keyName = this.props.uiMath.rowHeaderList[this.props.index]; // what key am I on?
            var titleText = keyName;
            if (this.props.GridStore.colDefListByKey[keyName]) {
              // is there a colDef that uses this key?
              titleText = this.props.GridStore.colDefListByKey[keyName].title || keyName; // if there is a title for the colDef use it, or just stick with thekey
            }

            if (this.props.uiMath.pivotRowHeaderWide) {
              cellStyleFirst.width = Number(this.props.uiMath.pivotRowHeaderWide);
            }
            isFirst = false;

            var helpComp = null;
            if (this.props.GridStore.colDefListByKey[keyName] && this.props.GridStore.colDefListByKey[keyName].altText) {
              helpComp = this.props.GridStore.colDefListByKey[keyName].altText;
            }

            // add in the row header style
            var gridColLocalStyle = {};
            if (this.props.GridStore.colDefListByKey[keyName]) {
              gridColLocalStyle = this.props.GridStore.colDefListByKey[keyName].styleHeader || {};
            }

            var rowHeaderStyle = _extends({}, cellStyleFirst, this.props.styleHeader, this.props.styleRowHeader, gridColLocalStyle);

            cellArray.push(_react2.default.createElement(
              'a',
              { onMouseEnter: function onMouseEnter(e) {
                  return _this2.showRowHeaderAltText(e, ctr, _this2.props.index);
                }, onMouseLeave: function onMouseLeave(e) {
                  return _this2.hideRowHeaderAltText(e, ctr, _this2.props.index);
                },
                key: this.props.index + '-RH' },
              _react2.default.createElement(_GridCell2.default, {
                id: this.props.index + '-RH',
                x: ctr,
                y: this.props.index,
                forceNoEdit: true,
                styleCell: rowHeaderStyle,
                isFirstColumn: true,
                GridStore: this.props.GridStore,
                data: this.props.data,
                cellData: titleText,
                uiMath: this.props.uiMath,
                onChange: this.props.onChange
              })
            ));
          }
        } else {

          var curColKey = this.props.uiMath.colHeaderKeyList[ctr]; // the xth column defined in the colHeaderKey list
          if (this.props.pivotOn) {
            if (this.props.GridStore.colDefListByIdx) {
              // pvt ON, colDef ON
              //console.log(this.props.index, this.props.GridStore.colDefListByIdx[this.props.index]);
              curColKey = this.props.uiMath.rowHeaderList[this.props.index];
            } else {
              curColKey = this.props.uiMath.colHeaderKeyList[this.props.index + 1]; // use Y instead of X and ofset for the row header.  this seems like it could be smoother.
              //curColKey = this.props.index; // use Y instead of X and ofset for the row header.  this seems like it could be smoother.
            }
          }
          var cellData = this.props.GridStore.getDataRespectingPivotAtLocation(this.props.data, ctr, this.props.index);

          cellArray.push(_react2.default.createElement(_GridCell2.default, {
            key: this.props.index + '-' + ctr,
            id: this.props.index + '-' + ctr,
            x: ctr,
            y: this.props.index,
            objKey: curColKey,
            styleInput: inputStyleLocal,
            styleCell: cellStyleLocal,
            isFirstColumn: isFirst,
            GridStore: this.props.GridStore,
            data: this.props.data,
            cellData: cellData,
            uiMath: this.props.uiMath,
            onChange: this.props.onChange
          }));
          isFirst = false;
        }
      }

      return _react2.default.createElement(
        'div',
        null,
        helpComp && // only render this if helpComp is defined
        _react2.default.createElement(
          _reactTooltip2.default,
          { id: 'dataTip' + keyName, effect: 'solid', place: 'right' },
          helpComp
        ),
        cellArray
      );
    }
  }]);

  return GridRow;
}(_react2.default.Component)) || _class;

exports.default = GridRow;
module.exports = exports['default'];