'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _descriptor14, _descriptor15, _descriptor16;

var _mobx = require('mobx');

var _GridMath = require('./GridMath');

var _GridMath2 = _interopRequireDefault(_GridMath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var GridStore = (_class = function () {
  // Just a class.  Nothing fancy here.
  function GridStore() {
    _classCallCheck(this, GridStore);

    _initDefineProp(this, 'cursor', _descriptor, this);

    _initDefineProp(this, 'selectedCells', _descriptor2, this);

    _initDefineProp(this, 'curEditingValue', _descriptor3, this);

    _initDefineProp(this, 'autoFocus', _descriptor4, this);

    _initDefineProp(this, 'inst', _descriptor5, this);

    _initDefineProp(this, 'pivotOn', _descriptor6, this);

    _initDefineProp(this, 'colDefListByKey', _descriptor7, this);

    _initDefineProp(this, 'colDefListByIdx', _descriptor8, this);

    _initDefineProp(this, 'keyList', _descriptor9, this);

    _initDefineProp(this, 'showDatePicker', _descriptor10, this);

    _initDefineProp(this, 'showDateTimePicker', _descriptor11, this);

    _initDefineProp(this, 'showMenuPicker', _descriptor12, this);

    _initDefineProp(this, 'showOverlayComp', _descriptor13, this);

    _initDefineProp(this, 'jsonAsTxtError', _descriptor14, this);

    _initDefineProp(this, 'textDataLinesLength', _descriptor15, this);

    _initDefineProp(this, 'textGoalFormat', _descriptor16, this);

    this.uiMathInst = new _GridMath2.default();
  } // for control clicking cells.
  // value being edited before it is applied.

  // if true, rendering a selected cell will cause that cell to take focus
  // if true, rendering a selected cell will cause that cell to take focus
  // from props.  Here for easy cell access.

  // column definition meta data accessible by keyName
  // column definition meta data accessible by ordered index
  // list of the keys in the given data object.

  // due to scrolling issues, the react-datepicker popup cannot be used.  This add a non-scrolled over-lay picker.
  // due to scrolling issues, the react-datepicker popup cannot be used.  This add a non-scrolled over-lay picker.
  // due to scrolling issues, the react-datepicker popup cannot be used.  This add a non-scrolled over-lay picker.


  _createClass(GridStore, [{
    key: 'makeValidInt',
    // due to scrolling issues, the react-datepicker popup cannot be used.  This add a non-scrolled over-lay picker.


    // javascript sucks at math
    value: function makeValidInt(inputVal, defaultVal) {
      var res = inputVal || defaultVal;
      if (inputVal === 0) {
        res = inputVal;
      }
      if (res < 0) {
        res = defaultVal;
      }
      return Number(res);
    }
  }, {
    key: 'logNoChangeHandlerMessage',
    value: function logNoChangeHandlerMessage() {
      console.log('no onChange handler supplied.');
    }
  }, {
    key: 'logNoOnRowAddHandlerMessage',
    value: function logNoOnRowAddHandlerMessage() {
      console.log('no onRowAdd handler supplied.');
    }
  }, {
    key: 'logNoOnRowCutHandlerMessage',
    value: function logNoOnRowCutHandlerMessage() {
      console.log('no onRowCut handler supplied.');
    }
  }, {
    key: 'logNoOnGotoPageHandlerMessage',
    value: function logNoOnGotoPageHandlerMessage() {
      console.log('no onGotoPage handler supplied.');
    }
  }, {
    key: 'logNoOnImportHandlerMessage',
    value: function logNoOnImportHandlerMessage() {
      console.log('no onImport handler supplied.');
    }
  }, {
    key: 'logNoOnExportHandlerMessage',
    value: function logNoOnExportHandlerMessage() {
      console.log('no onExport handler supplied.');
    }
  }, {
    key: 'logNoOnReplaceDataHandlerMessage',
    value: function logNoOnReplaceDataHandlerMessage() {
      console.log('no onReplaceData handler supplied. (Required for text mode editing)');
    }

    // don't call the user supplied on change directly.  
    // call this to ensure that the pivot variables get swizzled correctly.

  }, {
    key: 'onChangePivotWrapper',
    value: function onChangePivotWrapper(x, y, objKey, val) {
      if (val === null) return; // cannot set null via the UI.  prevents unintended changes.
      if (this.pivotOn) {
        this.onChange(y, x, objKey, val);
      } else {
        this.onChange(x, y, objKey, val);
      }
    }

    /* 	
    something funky here:
    this method takes the props and updates the grid store.
    However, the gridStore is ALSO part of the props.  So once this method id done, it will be called again with the newly updated props.
    The method must give the same results again in order not to get into a loop of re-changing props each round. 
    I'd love a cleaner solution to this, but not sure what that would be yet.
    */

  }, {
    key: 'prepSelectionField',
    value: function prepSelectionField(props) {
      // make the calculations
      this.uiMath = this.uiMathInst.calcGridBody(props, this.scrollBarWide || 20);

      // ease of access
      this.colDefListByKey = this.uiMath.colDefListByKey;
      this.colDefListByIdx = props.columnList;

      this.styleSelectedCell = props.styleSelectedCell || {}; // just for ease of access
      this.classNameHeaderCell = props.classNameHeaderCell || '';
      this.classNameHeaderData = props.classNameHeaderData || '';
      this.classNameHeaderRowCell = props.classNameHeaderRowCell || '';
      this.classNameHeaderRowData = props.classNameHeaderRowData || '';

      this.keyList = this.uiMath.keyNames;

      var dataWide = this.uiMath.dataWide;
      var dataHigh = this.uiMath.dataHigh;

      // ensure that we only set the values if they've actuallly changed.
      if (this.cursor.maxX !== dataWide - 1 || this.cursor.maxY !== dataHigh - 1) {
        this.cursor.maxX = dataWide - 1;
        this.cursor.maxY = dataHigh - 1;
      }

      // make handlers easily available and log messages if they're missing.
      this.onChange = props.onChange || this.logNoChangeHandlerMessage;
      this.onRowAdd = props.onRowAdd || this.logNoOnRowAddHandlerMessage;
      this.onRowCut = props.onRowCut || this.logNoOnRowCutHandlerMessage;
      this.onGotoPage = props.onGotoPage || this.logNoGotoPageHandlerMessage;
      this.onExport = props.onExport || this.logNoOnExportHandlerMessage;
      this.onImport = props.onImport || this.logNoOnImportHandlerMessage;
      this.onReplaceData = props.onReplaceData || this.logNoOnReplaceDataHandlerMessage;

      this.pivotOn = props.pivotOn; // easy availability to cells
    }
  }, {
    key: 'cellSelectSet',
    value: function cellSelectSet(x, y, val) {
      selectedCells[y][x] = val;
    }
  }, {
    key: 'cellMoveKey',
    value: function cellMoveKey(e) {
      // only worry about arrow keys:
      if (e.shiftKey) {
        // was it already down?  if no, start a selection
        // note: google sheets does not allow 2 separate shift-cell-selections at a time.  It's one block+click collection , but not 2 blocks.
        if (!this.cursor.shiftSelInProgress) {
          this.cursor.selectToX = this.cursor.x;
          this.cursor.selectToY = this.cursor.y;
          this.cursor.shiftSelInProgress = true;
        }
      } else {
        this.cursor.shiftSelInProgress = false;
      }
      if (e.keyCode == '38') {
        // up arrow
        this.cursor.y--;
        if (this.cursor.y < 0) this.cursor.y = 0;
      } else if (e.keyCode == '40') {
        // down arrow
        if (this.cursor.y < this.cursor.maxY) this.cursor.y++;
      } else if (e.keyCode == '37') {
        // left arrow
        this.cursor.x--;
        if (this.cursor.x < 0) this.cursor.x = 0;
      } else if (e.keyCode == '39') {
        // right arrow
        if (this.cursor.x < this.cursor.maxX) this.cursor.x++;
      }
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: 'checkValidInt',
    value: function checkValidInt(t) {
      if (!t) return true; // blank+null is ok.  
      return !isNaN(t) && function (x) {
        return (x | 0) === x;
      }(parseFloat(t));
    }
  }, {
    key: 'checkValidFloat',
    value: function checkValidFloat(t) {
      if (!t) return true; // blank+null is ok.
      return !isNaN(t);
    }
  }, {
    key: 'getDataRespectingPivotAtEditCursor',
    value: function getDataRespectingPivotAtEditCursor(clientData) {
      if (this.uiMath.isPrimitiveData) {
        // non-object data.  Just pretend it's a grid.  Only one coordinate will matter.
        if (this.pivotOn) {
          return clientData[this.cursor.editY]; // y is rows down / outer array
        } else {
          return clientData[this.cursor.editX];
        }
      } else {
        if (this.pivotOn) {
          return clientData[this.cursor.editX][this.uiMath.rowHeaderList[this.cursor.editY]]; // y is rows down / outer array        
        } else {
          return clientData[this.cursor.editY][this.uiMath.colHeaderKeyList[this.cursor.editX]];
        }
      }
    }
  }, {
    key: 'getDataRespectingPivotAtLocation',
    value: function getDataRespectingPivotAtLocation(clientData, x, y) {
      if ((typeof clientData === 'undefined' ? 'undefined' : _typeof(clientData)) !== "object") {
        console.log('Remember that the first parameter of this method must be the user client data.  Currently it is ' + clientData);
      }
      if (this.uiMath.isPrimitiveData) {
        // non-object data.  Just pretend it's a grid.  Only one coordinate will matter.
        if (this.pivotOn) {
          return clientData[x]; // y is rows down / outer array
        } else {
          return clientData[y];
        }
      } else {
        // object data.  Use the real stuff.
        if (this.pivotOn) {
          return clientData[x][this.uiMath.rowHeaderList[y]]; // x data items into outer list.  Y+1 adjusts for the "/" column heading
        } else {
          return clientData[y][this.uiMath.colHeaderKeyList[x]]; // y is depth in outer list, x is the column into the inner list/object
        }
      }
    }
  }, {
    key: 'convertJSONtoTXT',
    value: function convertJSONtoTXT(data) {
      this.textDataLinesLength = 0;
      this.keyList = [];
      var res = '';

      if (!data || data.length === 0) {
        return '';
      }
      this.textDataLinesLength = data.length;

      if (_typeof(data[0]) === 'object' || typeof data[0] === 'array') {

        this.textGoalFormat = _typeof(data[0]);
        this.textDataLinesLength = data.length;
        this.keyList = Object.keys(data[0]);
        if (this.keyList.length === 0) {
          // fake object.  Treat it as an array
          this.textGoalFormat = 'array';
          if (data[0].length) {
            for (var fi = 0; fi < data[0].length; fi++) {
              this.keyList.push(fi);
            }
          }
        }

        this.cursor.objKey = this.keyList[0];
        for (var y = 0; y < data.length; y++) {
          var line = '';
          for (var x = 0; x < this.keyList.length; x++) {
            line += data[y][this.keyList[x]] + '|';
          }
          res += line.substring(0, line.length - 1) + '\n';
        }
        return res.trim();
        //return data.map(x=>x[this.cursor.objKey]).join('\n');  // get the "objKey"th item from each object into an array of primitives then newline-join it together for the response.
      } else {
        this.textGoalFormat = 'prims'; // single array of primitives
        return data.join('\n').trim();
      }
    }

    // TODO
    // - Make this return a full, reconstituted data object.
    // - tool button to switch between editor types.
    // - remember if the input was obj, array, or prim array and use it to convert back
    // - ALSO: Get components working everywhere, then close to ready to ship it!

  }, {
    key: 'convertTXTtoJSON',
    value: function convertTXTtoJSON(txt) {
      var lines = txt.split('\n');
      // bonehead implementation.  this is intended for lists of less than 200 items.
      var result = [];
      for (var ctr = 0; ctr < lines.length; ctr++) {
        if (this.textGoalFormat === 'prims') {
          result.push(lines[ctr]);
        } else if (this.textGoalFormat === 'array') {
          var items = lines[ctr].split('|');
          result.push(items);
        } else if (this.textGoalFormat === 'object') {
          var curObj = {};
          var items = lines[ctr].split('|');
          for (var kctr = 0; kctr < this.keyList.length; kctr++) {
            if (items.length > kctr) {
              curObj[this.keyList[kctr]] = items[kctr];
            } else {
              curObj[this.keyList[kctr]] = '';
            }
          }
          result.push(curObj);
        }
      }

      if (this.uiMath.debugGridMath) {
        console.log(result);
      }
      this.onReplaceData(result);
    }
  }, {
    key: 'selectionBounds',
    get: function get() {
      var res = { l: -1, r: -1, t: -1, b: -1 };
      // block selection 
      if (this.cursor.shiftSelInProgress) {
        res.l = Math.min(this.cursor.x, this.cursor.selectToX);
        res.r = Math.max(this.cursor.x, this.cursor.selectToX);
        res.t = Math.min(this.cursor.y, this.cursor.selectToY);
        res.b = Math.max(this.cursor.y, this.cursor.selectToY);
      } else {
        res.l = res.r = this.cursor.x;
        res.t = res.b = this.cursor.y;
      }
      // click selection

      return res;
    }
  }, {
    key: 'curEditIsValidFor',
    get: function get() {
      var res = {};
      res.isValidInt = this.checkValidInt(this.curEditingValue);
      res.isValidFloat = this.checkValidFloat(this.curEditingValue);
      return res;
    }
  }]);

  return GridStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'cursor', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return { x: 0, y: 0, // cursor x and y values
      maxX: -1, maxY: -1, // max legal x and y values.
      selectToX: -1, selectToY: -1, // selection box for shift selection
      editX: -1, editY: -1, editObjKey: -1, // cell being edited
      showAltX: -1, showAltY: -1, // for displaying alt text help
      shiftSelInProgress: false // for shift arrow selecting cells
    };
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'selectedCells', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'curEditingValue', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'autoFocus', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor5 = _applyDecoratedDescriptor(_class.prototype, 'inst', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor6 = _applyDecoratedDescriptor(_class.prototype, 'pivotOn', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor7 = _applyDecoratedDescriptor(_class.prototype, 'colDefListByKey', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor8 = _applyDecoratedDescriptor(_class.prototype, 'colDefListByIdx', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor9 = _applyDecoratedDescriptor(_class.prototype, 'keyList', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return [];
  }
}), _descriptor10 = _applyDecoratedDescriptor(_class.prototype, 'showDatePicker', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor11 = _applyDecoratedDescriptor(_class.prototype, 'showDateTimePicker', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor12 = _applyDecoratedDescriptor(_class.prototype, 'showMenuPicker', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _descriptor13 = _applyDecoratedDescriptor(_class.prototype, 'showOverlayComp', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'logNoChangeHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoChangeHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'logNoOnRowAddHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoOnRowAddHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'logNoOnRowCutHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoOnRowCutHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'logNoOnGotoPageHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoOnGotoPageHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'logNoOnImportHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoOnImportHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'logNoOnExportHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoOnExportHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'logNoOnReplaceDataHandlerMessage', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'logNoOnReplaceDataHandlerMessage'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'prepSelectionField', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'prepSelectionField'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'cellSelectSet', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'cellSelectSet'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'cellMoveKey', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'cellMoveKey'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'selectionBounds', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'selectionBounds'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'curEditIsValidFor', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'curEditIsValidFor'), _class.prototype), _descriptor14 = _applyDecoratedDescriptor(_class.prototype, 'jsonAsTxtError', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _descriptor15 = _applyDecoratedDescriptor(_class.prototype, 'textDataLinesLength', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return 0;
  }
}), _descriptor16 = _applyDecoratedDescriptor(_class.prototype, 'textGoalFormat', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _applyDecoratedDescriptor(_class.prototype, 'convertJSONtoTXT', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'convertJSONtoTXT'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'convertTXTtoJSON', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'convertTXTtoJSON'), _class.prototype)), _class);
exports.default = GridStore;
module.exports = exports['default'];