'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _desc, _value, _class2, _descriptor;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _GridHeader = require('./GridHeader');

var _GridHeader2 = _interopRequireDefault(_GridHeader);

var _GridTools = require('./GridTools');

var _GridTools2 = _interopRequireDefault(_GridTools);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

// Wrapper for the grid
// This grid allows deep styling via style objects, 
// but retains control of border and padding to ensure that the grid lines up.
var GridTextBox = (0, _mobxReact.observer)(_class = (_class2 = function (_React$Component) {
  _inherits(GridTextBox, _React$Component);

  // keep track of how wide the scroll bar will be

  function GridTextBox(props) {
    _classCallCheck(this, GridTextBox);

    var _this = _possibleConstructorReturn(this, (GridTextBox.__proto__ || Object.getPrototypeOf(GridTextBox)).call(this, props));

    _initDefineProp(_this, 'txt', _descriptor, _this);

    (0, _reactAutobind2.default)(_this);
    _this.componentWillReceiveProps(props); // first call needs to set up the data store
    //this.refuseUpdates=false;
    return _this;
  }

  _createClass(GridTextBox, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      //if(this.refuseUpdates){return;}

      var testTxt = this.props.GridStore.convertJSONtoTXT(nextProps.data);
      if (this.txt !== testTxt) {
        this.txt = testTxt; // don't set the value unless you have to, it will move the cursor!
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(evt) {
      //if (this.refuseUpdates) return;
      var curText = evt.target.value;

      if (this.txt !== curText) {
        this.refuseUpdates = true;
        this.props.GridStore.convertTXTtoJSON(curText);
        this.txt = curText;
        this.refuseUpdates = false;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var ui = this.props.uiMath;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_GridHeader2.default, _extends({ uiMath: ui }, this.props)),
        _react2.default.createElement('textarea', { style: { width: ui.rowWide - (ui.padWide || 0) * 2,
            height: ui.gridHigh,
            borderStyle: 'solid',
            borderColor: 'black',
            padding: (ui.padWide || 0) + 'px',
            borderLeftWidth: ui.borderWide,
            borderRightWidth: ui.borderWide,
            borderBottomWidth: ui.borderWide
          },
          onChange: this.onChange, value: this.txt, disabled: this.props.editDisabled }),
        _react2.default.createElement(_GridTools2.default, _extends({ uiMath: ui }, this.props))
      );
    }
  }]);

  return GridTextBox;
}(_react2.default.Component), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'txt', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'onChange', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onChange'), _class2.prototype)), _class2)) || _class;

exports.default = GridTextBox;
module.exports = exports['default'];