'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _Grid = require('../Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _reallyRelaxedJson = require('really-relaxed-json');

var _reallyRelaxedJson2 = _interopRequireDefault(_reallyRelaxedJson);

require('../TestCSS.css');

var _Toggle = require('./Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

var _ToggleFolder = require('./ToggleFolder');

var _ToggleFolder2 = _interopRequireDefault(_ToggleFolder);

var _NumWheel = require('./NumWheel');

var _NumWheel2 = _interopRequireDefault(_NumWheel);

var _TextParam = require('./TextParam');

var _TextParam2 = _interopRequireDefault(_TextParam);

var _CompactObjView = require('./CompactObjView');

var _CompactObjView2 = _interopRequireDefault(_CompactObjView);

var _DataMaker = require('./DataMaker');

var _DataMaker2 = _interopRequireDefault(_DataMaker);

var _DocStore = require('./DocStore');

var _DocStore2 = _interopRequireDefault(_DocStore);

var _dataNoiseMedium = require('../../stories/dataNoiseMedium.js');

var _dataNoiseMedium2 = _interopRequireDefault(_dataNoiseMedium);

var _dataNoiseSmall = require('../../stories/dataNoiseSmall.js');

var _dataNoiseSmall2 = _interopRequireDefault(_dataNoiseSmall);

var _dataNoiseGiant = require('../../stories/dataNoiseGiant.js');

var _dataNoiseGiant2 = _interopRequireDefault(_dataNoiseGiant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var DocUI = (0, _mobxReact.observer)(_class = (_class2 = function (_React$Component) {
  _inherits(DocUI, _React$Component);

  function DocUI(props) {
    _classCallCheck(this, DocUI);

    var _this = _possibleConstructorReturn(this, (DocUI.__proto__ || Object.getPrototypeOf(DocUI)).call(this, props));

    _initDefineProp(_this, 'data', _descriptor, _this);

    _initDefineProp(_this, 'cleanData', _descriptor2, _this);

    _initDefineProp(_this, 'dataErr', _descriptor3, _this);

    _initDefineProp(_this, 'curParamHelp', _descriptor4, _this);

    (0, _reactAutobind2.default)(_this);
    _this.rrjs = _reallyRelaxedJson2.default.createParser();
    _this.printer = new _reallyRelaxedJson2.default.PrettyPrinter(_reallyRelaxedJson2.default.PrettyPrinter.Options.Companion.JsonPretty);
    _this.dm = new _DataMaker2.default(_this.updateDataText);
    _this.ds = new _DocStore2.default();
    _this.dataAsObject();
    return _this;
  } // the data AS A STRING for the test editor
  // the data AS JSON for the fast editor


  _createClass(DocUI, [{
    key: 'updateData',
    value: function updateData(evt) {
      this.data = evt.target.value;
      this.dataAsObject();
    }
  }, {
    key: 'updateDataText',
    value: function updateDataText(txt) {
      this.data = txt;
      this.dataAsObject();
    }
  }, {
    key: 'setValue',
    value: function setValue(x, y, objKey, newValue) {
      // this is just for the test UI.  By making the "source of truth" the text file, i keep things in sync
      // cost is that I lose update performance for this test UI.  Try another test gui for perf testing.
      if (!this.ds.hideEditor) {
        this.cleanData = JSON.parse(this.rrjs.stringToJson(this.data));
        this.cleanData[y][objKey] = newValue;
        this.data = JSON.stringify(this.cleanData);
      } else {
        this.cleanData[y][objKey] = newValue;
      }
    }
  }, {
    key: 'cleanClone',
    value: function cleanClone() {
      var target = {};
      Object.assign(target, this.cleanData[0]);
      var keyList = Object.keys(this.cleanData[0]);
      for (var kc = 0; kc < keyList.length; kc++) {
        target[keyList[kc]] = '';
      }
      return target;
    }
  }, {
    key: 'onRowAdd',
    value: function onRowAdd(x, y, objKey) {
      if (!this.ds.hideEditor) {
        this.cleanData = JSON.parse(this.rrjs.stringToJson(this.data));
        this.cleanData.splice(y + 1, 0, this.cleanClone());
        this.data = JSON.stringify(this.cleanData);
      } else {
        this.cleanData.splice(y + 1, 0, this.cleanClone());
      }
    }
  }, {
    key: 'onRowCut',
    value: function onRowCut(x, y, objKey) {
      if (!this.ds.hideEditor) {
        this.cleanData = JSON.parse(this.rrjs.stringToJson(this.data));
        this.cleanData.splice(y, 1);
        this.data = JSON.stringify(this.cleanData);
      } else {
        this.cleanData.splice(y, 1);
      }
    }
  }, {
    key: 'onReplaceData',
    value: function onReplaceData(newData) {
      if (!this.ds.hideEditor) {
        this.cleanData = newData;
        this.data = JSON.stringify(this.cleanData);
      } else {
        this.cleanData = newData;
      }
    }
  }, {
    key: 'onColAdd',
    value: function onColAdd(x, y, objKey) {} // not implemented yet.  

  }, {
    key: 'onColCut',
    value: function onColCut(x, y, objKey) {} // not implemented yet.

  }, {
    key: 'onDataClear',
    value: function onDataClear(x, y, objKey) {} // not implemented yet.

  }, {
    key: 'onGotoPage',
    value: function onGotoPage(page) {
      window.alert('please load page ' + page);
    }
  }, {
    key: 'onExport',
    value: function onExport() {
      window.alert('please export');
    }
  }, {
    key: 'onImport',
    value: function onImport() {
      window.alert('please import');
    }
  }, {
    key: 'dataAsObject',
    value: function dataAsObject() {
      this.cleanData = [];
      this.dataErr = "";
      try {
        this.cleanData = JSON.parse(this.rrjs.stringToJson(this.data));
        if (this.cleanData && _typeof(this.cleanData) === "object") {
          this.dataErr = "";
        } else {
          this.cleanData = [];this.dataErr = "Invalid JSON.";
        }
      } catch (e) {
        try {
          this.cleanData = JSON.parse(this.data);
        } catch (e2) {
          this.dataErr = "Invalid JSON.  Keys and values need to be in quotes.";console.log(e);
        }
      }
    }
  }, {
    key: 'goMakeL',
    value: function goMakeL() {
      this.dataErr = "Building 50K objects...  Disabling text data editor for performance.";
      this.ds.hideEditor = true;
      this.ds.showDebugStuff = true;
      var saneThis = this;
      setTimeout(function () {
        saneThis.dm.makeL();saneThis.dataErr = '';
      }, 100);
    }
  }, {
    key: 'goMakeLA',
    value: function goMakeLA() {
      this.dataErr = "Building 50K arrays...  Disabling text data editor for performance.";
      this.ds.hideEditor = true;
      this.ds.showDebugStuff = true;
      var saneThis = this;
      setTimeout(function () {
        saneThis.dm.makeLA();saneThis.dataErr = '';
      }, 100);
    }
  }, {
    key: 'render',
    value: function render() {

      var colListAsText = [];
      for (var cctr = 0; cctr < this.ds.colDef.length; cctr++) {
        colListAsText.push(_react2.default.createElement(_CompactObjView2.default, { target: this.ds.colDef[cctr], key: JSON.stringify(this.ds.colDef[cctr]) + cctr }));
      }

      return _react2.default.createElement(
        'div',
        { style: { overflowY: 'hidden', height: window.innerHeight - 20 + 'px' } },
        _react2.default.createElement(
          'div',
          { style: { paddingLeft: '15px', position: 'absolute', top: '0px', bottom: '0px', left: '0px', width: '450px', overflow: 'auto',
              borderRight: '2px solid grey', verticalAlign: 'top', backgroundColor: '#fff8ed' } },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'div',
              { style: { fontSize: '3em', textAlign: 'center' } },
              'react-json-grid'
            ),
            _react2.default.createElement(
              'div',
              { style: { fontSize: '1.5em', textAlign: 'center' } },
              'Easy to use, high performance Data Grid'
            ),
            _react2.default.createElement(
              'p',
              null,
              'This is the documentation UI.',
              _react2.default.createElement('br', null),
              'Use this page to explore the features of react-json-grid.',
              _react2.default.createElement('br', null),
              'The grid is editable by default.  Feel free to play with the data.'
            ),
            _react2.default.createElement('br', null),
            'Example Data Generators',
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeS },
              '5 objects'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeM },
              '150 objects'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.goMakeL },
              '50K objects'
            ),
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeSA },
              '5 arrays'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeMA },
              '150 arrays'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.goMakeLA },
              '50K arrays'
            ),
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeAInt },
              'int[]'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeAWords },
              'word[]'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeKVP },
              'key : value[]'
            ),
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeCSV },
              'CSV'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makePSV },
              'PSV'
            ),
            _react2.default.createElement(
              'button',
              { style: { width: '90px' }, onClick: this.dm.makeKVE },
              'key=value[]'
            ),
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'span',
              { style: { color: 'red' } },
              this.dataErr
            ),
            _react2.default.createElement('br', null),
            '{this.data}',
            _react2.default.createElement('br', null),
            !this.ds.hideEditor && _react2.default.createElement('textarea', { style: { width: '400px', height: '75px' }, onChange: this.updateData, value: this.data }),
            _react2.default.createElement('br', null),
            _react2.default.createElement('br', null),
            'Parameter UI',
            _react2.default.createElement('br', null),
            _react2.default.createElement(
              'div',
              { style: { display: 'inline-block', verticalAlign: 'top', margin: '5px' } },
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowSizeStuff, toggleValue: this.ds.showSizeStuff, label: 'Sizing', help: 'display API for sizing' }),
              this.ds.showSizeStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setBorderWidth, curValue: this.ds.propBorderWide, mouseOverValue: 5, label: 'borderWide', help: 'width of the border between cells' }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setPadWidth, curValue: this.ds.propPadWide, label: 'padWide', mouseOverValue: 5, help: 'width of the padding inside each cell' }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setGridWide, incr: 100, curValue: this.ds.propGridWide, mouseOverValue: 150, label: 'gridWide', help: _react2.default.createElement(
                    'div',
                    null,
                    'Forced width of the grid.',
                    _react2.default.createElement('br', null),
                    'Not set by CSS because the number is needed for javascript calculations.'
                  ) }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setGridHigh, incr: 100, curValue: this.ds.propGridHigh, mouseOverValue: 250, label: 'gridHigh', help: _react2.default.createElement(
                    'div',
                    null,
                    'Forced height of the grid.',
                    _react2.default.createElement('br', null),
                    'Not set by CSS because the number is needed for javascript calculations.'
                  ) }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setRowHigh, curValue: this.ds.propRowHigh, label: 'rowHigh', mouseOverValue: 50, help: 'over-ride default row height' }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setRowHeaderHigh, curValue: this.ds.propRowHeaderHigh, mouseOverValue: 50, label: 'colHeaderHigh', help: 'over-ride row header height' }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setMinColWide, incr: 5, curValue: this.ds.propMinColWide, mouseOverValue: 50, label: 'minColWide', help: 'forced minimum auto grid width.  Over-ridden by column properties.' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleColHeaderHide, toggleValue: this.ds.colHeaderHide, label: 'colHeaderHide', help: 'hide/show column header.' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleGridHighCollapse, toggleValue: this.ds.gridHighCollapse, label: 'gridHighCollapse', help: 'If there are fewer rows than needed by the gridHigh setting, shrink the height of the grid.  Otherwise, use the full space.' })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleColumnList, toggleValue: this.ds.columnList, label: 'Columns', help: 'define column meta data' }),
              this.ds.columnList && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement(_Grid2.default, {
                  data: this.ds.colDef,
                  columnList: [{ key: 'key', altText: 'key name (or index) of the data for this column.  You can re-order the key names to re-order the columns displayed.' }, { key: 'title', altText: 'text in the title bar of the column' }, { key: 'editDisabled', easyBool: true, altText: 'disable editing for this column' }, { key: 'widePct', easyFloat: true, altText: 'percent of grid width to make this column.  Too big will cause side scrolling!' }, { key: 'widePx', easyInt: true, altText: 'width in pixels to make this column.  Too big will cause side scrolling!' }, { key: 'easyBool', easyBool: true, altText: 'render this column as a check box' }, { key: 'easyInt', easyBool: true, altText: 'render and validate this column as an integer' }, { key: 'easyFloat', easyBool: true, altText: 'render and validate this column as an float' }, { key: 'easyMoneyDollar', easyBool: true, altText: 'render and validate this column as dollars' }, { key: 'easyMoneyEuro', easyBool: true, altText: 'render and validate this column as euros' }, { key: 'easyMoneyPound', easyBool: true, altText: 'render and validate this column as pounds' }, { key: 'easyDate', easyBool: true, altText: 'render and validate this column as a date' }, { key: 'easyDateTime', easyBool: true, altText: 'render and validate this column as a datetime' }, { key: 'easyMenu', altText: 'render and validate this column as a menu. supply an array of values easyMenu={[a,b,c,d]} or a pipe separated list easyMenu={"a|b|c|d"}' }, { key: 'altText', altText: 'provide help text when mousing over the column header' }],
                  pivotOn: 'title',
                  pivotRowHeaderWide: 125,
                  onChange: this.ds.setColDefValue,
                  styleRowHeader: { textAlign: 'left' },
                  gridHigh: 600,
                  gridWide: 425
                })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowEditStuff, toggleValue: this.ds.showEditStuff, label: 'Tools', help: 'display edit tools' }),
              this.ds.showEditStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleToolsAddCut, toggleValue: this.ds.showToolsAddCut, label: 'showToolsAddCut', help: 'shows buttons to add/remove rows' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleToolsPage, toggleValue: this.ds.showToolsPage, label: 'showToolsPage', help: 'show buttons to select different pages of data' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleToolsImpExp, toggleValue: this.ds.showToolsImpExp, label: 'showToolsImpExp', help: 'show buttons to import or export the data' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleToolsCustom, toggleValue: this.ds.showToolsCustom, label: 'showToolsCustom', help: _react2.default.createElement(
                    'div',
                    null,
                    'shows user supplied buttons.',
                    _react2.default.createElement('br', null),
                    'Note that you must supply an array of components to this attribute'
                  ) }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleEditDisabled, toggleValue: this.ds.editDisabled, label: 'editDisabled', help: 'disable all grid editing' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleEditAsText, toggleValue: this.ds.editAsText, label: 'editAsText', help: _react2.default.createElement(
                    'div',
                    null,
                    'Converts the JSON to pipe delimited text',
                    _react2.default.createElement('br', null),
                    'one item per line, for easy text editing.',
                    _react2.default.createElement('br', null),
                    'Best for one dimensional arrays.'
                  ) })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowPivotStuff, toggleValue: this.ds.showPivotStuff, label: 'Pivot', help: 'display data pivot' }),
              this.ds.showPivotStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement(_Toggle2.default, { action: this.ds.togglePivotOn, toggleValue: this.ds.pivotOn, label: 'pivotOn', help: 'pivot the data on a key.' }),
                _react2.default.createElement(_NumWheel2.default, { action: this.ds.setPivotRowHeaderWide, incr: 25, curValue: this.ds.pivotRowHeaderWide, label: 'pivotRowHeaderWide', help: _react2.default.createElement(
                    'div',
                    null,
                    'when pivotOn is set,',
                    _react2.default.createElement('br', null),
                    'use this to set the pixel width of the row header'
                  ) })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowStyleStuff, toggleValue: this.ds.showStyleStuff, label: 'Style', help: 'display API for style objects' }),
              this.ds.showStyleStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                'NOTE: enter styles in the JSX format.',
                _react2.default.createElement('br', null),
                'For example:  {backgroundColor:\'blue\'}',
                _react2.default.createElement('br', null),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'background style objects'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setCellStyle, curValue: this.ds.styleCell, label: 'styleCell', help: 'style for cells.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setStyleCellOddRow, curValue: this.ds.styleCellOddRow, label: 'styleCellOddRow', help: 'style for cells in odd numbered rows.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setHeaderStyleCell, curValue: this.ds.styleHeaderCell, label: 'styleHeaderCell', help: 'style for column header cells (and row headers, if row header style is not specified.)' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setRowHeaderStyleCell, curValue: this.ds.styleRowHeaderStyleCell, label: 'styleRowHeaderCell', help: 'style for row header cells (only visible when pivotOn is set)' }),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'data style objects'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setStyleData, curValue: this.ds.styleData, label: 'styleData', help: 'style for data in cells' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setStyleDataOddRow, curValue: this.ds.styleDataOddRow, label: 'styleDataOddRow', help: 'style for data in cells in odd numbered rows.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setStyleHeaderData, curValue: this.ds.styleHeaderData, label: 'styleHeaderData', help: 'style for data in column header cells (and row headers, if row header style is not specified.)' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setStyleRowHeaderData, curValue: this.ds.styleRowHeaderData, label: 'styleRowHeaderData', help: 'style for data in row header cells (only visible when pivotOn is set)' }),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'selection/input classes'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setInputStyle, curValue: this.ds.styleInput, label: 'styleInput', help: 'style for default cells.  cannot control border or padding.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setStyleSelectedCell, curValue: this.ds.styleSelectedCell, label: 'styleSelectedCell', help: 'style object to apply to the currently selected cell' })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowClassStuff, toggleValue: this.ds.showClassStuff, label: 'Class', help: 'display API for css class usage' }),
              this.ds.showClassStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                'NOTE: here are some CSS class names to try:',
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'div',
                  { style: { marginLeft: '10px' } },
                  'GreenRotate',
                  _react2.default.createElement('br', null),
                  'PinkRotate',
                  _react2.default.createElement('br', null),
                  'RedRotate'
                ),
                _react2.default.createElement(
                  'div',
                  { style: { marginLeft: '10px' } },
                  'BackgroundBlue',
                  _react2.default.createElement('br', null),
                  'BackgroundYellow'
                ),
                _react2.default.createElement(
                  'div',
                  { style: { marginLeft: '10px' } },
                  'Gradient1',
                  _react2.default.createElement('br', null),
                  'Gradient2'
                ),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'background classes'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassCell, curValue: this.ds.classCell, label: 'classCell', help: 'class name for cell container boxes.  ( for example, background color )' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassCellOddRow, curValue: this.ds.classCellOddRow, label: 'classCellOddRow', help: 'class name for cell backgrounds on odd row numbers.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassHeaderCell, curValue: this.ds.classHeaderCell, label: 'classHeaderCell', help: 'classname to apply to header cells.  For example: background colors.  cannot control border or padding.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassRowHeaderCell, curValue: this.ds.classRowHeaderCell, label: 'classRowHeaderCell', help: 'style for row header cells when pivotOn is set.  cannot control border or padding.' }),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'data classes'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassData, curValue: this.ds.classData, label: 'classData', help: 'class name for cell data. (for example, rotations )' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassHeaderData, curValue: this.ds.classHeaderData, label: 'classHeaderData', help: 'classname to apply to header data. For example: text rotations where you do not want to rotate the cell itself.  cannot control border or padding.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassRowHeaderData, curValue: this.ds.classRowHeaderData, label: 'classRowHeaderData', help: 'style for row header cells when pivotOn is set.  cannot control border or padding.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassDataOddRow, curValue: this.ds.classDataOddRow, label: 'classDataOddRow', help: 'class name for cell data on odd row numbers.' }),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'selection/input classes'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassInput, curValue: this.ds.classInput, label: 'classInput', help: 'class name for input cells' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassSelected, curValue: this.ds.classSelected, label: 'classSelected', help: 'class name for selected cells..' })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowFormatStuff, toggleValue: this.ds.showFormatStuff, label: 'Format', help: 'display API for date, time and other formatters' }),
              this.ds.showFormatStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setFormatDate, curValue: this.ds.formatDate, label: 'formatDate', help: 'preferred date format.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setFormatTime, curValue: this.ds.formatTime, label: 'formatTime', help: 'preferred time format.' })
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowDebugStuff, toggleValue: this.ds.showDebugStuff, label: 'Debug', help: 'grid tools to help you debug your grid usage.' }),
              this.ds.showDebugStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleOutline, toggleValue: this.ds.showOutline, label: 'Show test outline', help: 'Not grid related.  Just shows an outline around the container holding the Grid.' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleDebugGridMath, toggleValue: this.ds.debugGridMath, label: 'debugGridMath', help: 'Look at the logs to see what the grid thinks sizes should be.  Used to debug external CSS issues.' }),
                _react2.default.createElement(_Toggle2.default, { action: this.ds.toggleEditor, toggleValue: this.ds.hideEditor, label: 'Hide text editor', help: 'Not grid related.  Keeping the data text editor in sync with the grid costs more performance than the grid does.  When running large data test, this editor is disabled.' }),
                '( The Example Data text editor',
                _react2.default.createElement('br', null),
                ' has much worse performance than react-json-grid.',
                _react2.default.createElement('br', null),
                'Use "Hide text editor" to disable it',
                _react2.default.createElement('br', null),
                ' while doing performance tests. )'
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowKeyboardStuff, toggleValue: this.ds.showKeyboardStuff, label: 'Keys', help: 'enabled keyboard bindings.' }),
              this.ds.showKeyboardStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                'Key Bindings: ',
                _react2.default.createElement('br', null),
                'Arrows, PgUp, PgDn, Home, End, ',
                _react2.default.createElement('br', null),
                'Enter, Shift-Enter, Tab, Shift-Tab, , Escape',
                _react2.default.createElement('br', null),
                'Ctrl-C, Ctrl-V, Ctrl-X.',
                _react2.default.createElement('br', null),
                _react2.default.createElement('br', null),
                'Multi-Select Features: ',
                _react2.default.createElement('br', null),
                'Block Select via Shift-Arrow Keys and Shift-Click',
                _react2.default.createElement('br', null)
              ),
              _react2.default.createElement(_ToggleFolder2.default, { action: this.ds.toggleShowCompStuff, toggleValue: this.ds.showCompStuff, label: 'Components', help: 'ability to use components for key items.' }),
              this.ds.showCompStuff && _react2.default.createElement(
                'div',
                { style: { marginLeft: '40px' } },
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  'u',
                  null,
                  'component slots'
                ),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassCell, curValue: this.ds.classCell, label: 'compCell', help: 'class name for cell container boxes.  ( for example, background color )' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassHeaderCell, curValue: this.ds.classHeaderCell, label: 'compHeader', help: 'classname to apply to header cells.  For example: background colors.  cannot control border or padding.' }),
                _react2.default.createElement(_TextParam2.default, { action: this.ds.setClassRowHeaderCell, curValue: this.ds.classRowHeaderCell, label: 'compRowHeader', help: 'style for row header cells when pivotOn is set.  cannot control border or padding.' })
              )
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { marginLeft: '25px', position: 'absolute', top: '0px', bottom: '0px', left: '455px', right: '0px', overflow: 'auto' } },
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          _react2.default.createElement(_Grid2.default, { style: { outline: this.ds.outlineCSS },
            gridHigh: this.ds.propGridHigh,
            gridWide: this.ds.propGridWide,
            editDisabled: this.ds.editDisabled,
            editAsText: this.ds.editAsText,

            styleHeader: this.ds.jsonHeaderStyleObject,
            styleRowHeader: this.ds.jsonRowHeaderStyleObject,
            styleInput: this.ds.jsonInputStyleObject,
            styleCell: this.ds.jsonCellStyleObject,
            setStyleSelectedCell: this.ds.jsonCellSelectedStyleObject,

            classNameHeaderCell: this.ds.classNameHeaderCell,
            classNameHeaderData: this.ds.classNameHeaderData,

            rowHigh: this.ds.propRowHigh,
            colHeaderHigh: this.ds.propRowHeaderHigh,
            colHeaderHide: this.ds.colHeaderHide,
            gridHighCollapse: this.ds.gridHighCollapse,
            borderWide: this.ds.propBorderWide,
            padWide: this.ds.propPadWide,
            data: this.cleanData,
            onChange: this.setValue,
            onRowAdd: this.onRowAdd,
            onRowCut: this.onRowCut,
            onReplaceData: this.onReplaceData,
            onColAdd: this.onColAdd,
            onColCut: this.onColCut,
            onImport: this.onImport,
            onExport: this.onExport,
            onGotoPage: this.onGotoPage,
            pivotOn: this.ds.pivotOn ? Object.keys(this.cleanData[0] || { a: 5 })[0] : null,
            pivotRowHeaderWide: this.ds.pivotRowHeaderWide,
            columnList: this.ds.columnList ? this.ds.colDef : null,
            showToolsAddCut: this.ds.showToolsAddCut,
            showToolsPage: this.ds.showToolsPage,
            showToolsImpExp: this.ds.showToolsImpExp,
            showToolsCustom: this.ds.showToolsCustom && _react2.default.createElement(
              'div',
              null,
              'Some Funky Thing'
            ),
            formatDate: this.ds.formatDate,
            formatTime: this.ds.formatTime,

            classCell: this.ds.classCell,
            classData: this.ds.classData,
            classHeaderCell: this.ds.classHeaderCell,
            classHeaderData: this.ds.classHeaderData,
            classRowHeaderCell: this.ds.classRowHeaderCell,
            classRowHeaderData: this.ds.classRowHeaderData,
            classCellOddRow: this.ds.classCellOddRow,
            classDataOddRow: this.ds.classDataOddRow,
            classInput: this.ds.classInput,
            classSelected: this.ds.classSelected,

            debugGridMath: this.ds.debugGridMath
          }),
          _react2.default.createElement('br', null),
          _react2.default.createElement(
            'div',
            { style: { font: '20px monospace' } },
            '<Grid',
            this.ds.propGridWide > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0gridWide={',
              this.ds.propGridWide,
              '}\xA0\xA0'
            ),
            this.ds.propGridHigh > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0gridHigh={',
              this.ds.propGridHigh,
              '}\xA0\xA0'
            ),
            this.ds.propRowHigh > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0rowHigh={',
              this.ds.propRowHigh,
              '}\xA0\xA0'
            ),
            this.ds.editDisabled && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0editDisabled={',
              '' + this.ds.editDisabled,
              '}\xA0\xA0'
            ),
            this.ds.editAsText && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0editAsText={',
              '' + this.ds.editAsText,
              '}\xA0\xA0'
            ),
            this.ds.propRowHeaderHigh > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0colHeaderHigh={',
              this.ds.propRowHeaderHigh,
              '}\xA0\xA0'
            ),
            this.ds.propBorderWide > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0borderWide={',
              this.ds.propBorderWide,
              '}\xA0\xA0'
            ),
            this.ds.pivotOn && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0pivotOn=',
              Object.keys(this.cleanData[0] || { a: 5 })[0],
              '\xA0\xA0'
            ),
            this.ds.pivotRowHeaderWide > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0pivotRowHeaderWide={',
              '' + this.ds.pivotRowHeaderWide,
              '}\xA0\xA0'
            ),
            this.ds.showToolsAddCut && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0showToolsAddCut'
            ),
            this.ds.showToolsImpExp && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0showToolsImpExp'
            ),
            this.ds.showToolsPage && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0showToolsPage'
            ),
            this.ds.showToolsCustom && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0showToolsCustom={',
              '<YourCustomComponent/>',
              '}\xA0\xA0'
            ),
            this.ds.propPadWide > -1 && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0padWide={',
              this.ds.propPadWide,
              '}\xA0\xA0'
            ),
            this.ds.colHeaderHide && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0colHeaderHide={',
              '' + this.ds.colHeaderHide,
              '}\xA0\xA0'
            ),
            this.ds.styleHeader && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0styleHeader={',
              this.ds.styleHeader,
              '}'
            ),
            this.ds.styleRowHeader && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0styleRowHeader={',
              this.ds.styleRowHeader,
              '}'
            ),
            this.ds.styleInput && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0styleInput={',
              this.ds.styleInput,
              '}'
            ),
            this.ds.styleCell && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0styleCell={',
              this.ds.styleCell,
              '}'
            ),
            this.ds.classCell && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classCell={',
              this.ds.classCell,
              '}'
            ),
            this.ds.classCellOddRow && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classCellOddRow={',
              this.ds.classCellOddRow,
              '}'
            ),
            this.ds.classHeaderCell && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classHeaderCell={',
              this.ds.classHeaderCell,
              '}'
            ),
            this.ds.classRowHeaderCell && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classRowHeaderCell={',
              this.ds.classRowHeaderCell,
              '}'
            ),
            this.ds.classData && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classData={',
              this.ds.classData,
              '}'
            ),
            this.ds.classDataOddRow && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classDataOddRow={',
              this.ds.classDataOddRow,
              '}'
            ),
            this.ds.classHeaderData && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classHeaderData={',
              this.ds.classHeaderData,
              '}'
            ),
            this.ds.classRowHeaderData && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classRowHeaderData={',
              this.ds.classRowHeaderData,
              '}'
            ),
            this.ds.classInput && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classInput={',
              this.ds.classInput,
              '}'
            ),
            this.ds.classSelected && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0classSelected={',
              this.ds.classSelected,
              '}'
            ),
            this.ds.formatDate && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0formatDate={',
              this.ds.formatDate,
              '}'
            ),
            this.ds.formatTime && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0formatTime={',
              this.ds.formatTime,
              '}'
            ),
            this.ds.gridHighCollapse && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0gridHighCollapse'
            ),
            this.ds.debugGridMath && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0debugGridMath'
            ),
            this.ds.columnList && _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement('br', null),
              '\xA0\xA0columnList={[',
              colListAsText,
              '\xA0\xA0]}'
            ),
            _react2.default.createElement('br', null),
            '\xA0\xA0data={this.data}',
            _react2.default.createElement('br', null),
            '\xA0\xA0onChange={(x,y,objKey,value)=>{}}\xA0\xA0',
            _react2.default.createElement('br', null),
            '/>'
          )
        )
      );
    }
  }]);

  return DocUI;
}(_react2.default.Component), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'data', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return _dataNoiseSmall2.default;
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'cleanData', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'dataErr', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'updateData', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'updateData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'updateDataText', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'updateDataText'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'setValue', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'setValue'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onRowAdd', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onRowAdd'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onRowCut', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onRowCut'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onReplaceData', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onReplaceData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onColAdd', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onColAdd'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onColCut', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onColCut'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onDataClear', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onDataClear'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onGotoPage', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onGotoPage'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onExport', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onExport'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onImport', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'onImport'), _class2.prototype), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, 'curParamHelp', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return "";
  }
})), _class2)) || _class;

exports.default = DocUI;
module.exports = exports['default'];